### Ragdoll for Blender

<br>

### Introduction

Welcome to Ragdoll! This is a "bridge" between Blender and Ragdoll "Core", which is the engine and API of Ragdoll. It is implemented via the Python API to Ragdoll Core, whereas other DCCs like Maya is implemented via the C++ API.

Under the hood, Ragdoll is similar to Blender and Maya, in that it also has a notion of objects, a scene graph, selection, undo and redo. The basic building blocks of a graphical editor.

<br>

### Operators

All of Ragdoll's operators live in `bpy.ops.ragdoll`.

| Operator         | Description
|:-----------------|:---------------
| `assign_markers` |

<br>

### Entity

Ragdoll operates on "entities", a term from ECS - Entity Component System. Where each "entity" is an identifier pointing to one or more "components" operated on one or more "systems".

### Registry

The "registry" is where all data Ragdoll knows about is stored.

### bpxId

As part of `ragdoll.vendor.bpx` every Object and PoseBone in Blender that Ragdoll operates on will have a `bpxId` property. This is a persistent identifier that survives undo and redo, which Blender would normally consider destructive to any Python object reference.

<br>

### ragdollId

Each object representing a Ragdoll "entity" is imbued with a `ragdollId` property. This property helps Ragdoll identify which objects should have an entity instantiated for it on scene-open.

<br>

### Handlers

- attributeSet
- saveState
- restoreState
- evaluateStartState
- evaluateCurrentState
- evaluateMembers
- parseInputGeometry
- optionSet
- selectionChanged
- executeCommand

<br>

#### Execute Command

<br>

### Developer Documentation

**Get entity from object**

Entities are stored as metadata in the BpxObject.

```py
xobj.data["entity"]
```

**Get object from entity**

The BpxObject is the alias of an entity.

```py
xobj = bpx.alias(entity)
```

**Get entity object from bone**

```py

```